"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

var TreeNode = function () {
  function TreeNode(val) {
    _classCallCheck(this, TreeNode);

    this.val = val;
    this.left = this.right = null;
  }

  _createClass(TreeNode, [{
    key: "insert",
    value: function insert(val) {
      var queue = [this];
      while (queue.length) {
        var node = queue.shift();
        if (!node.left) {
          node.left = new TreeNode(val);
          break;
        } else if (!node.right) {
          node.right = new TreeNode(val);
          break;
        } else {
          if (node.left.val !== null) {
            queue.push(node.left);
          }
          if (node.right.val !== null) {
            queue.push(node.right);
          }
        }
      }
      return this;
    }
  }, {
    key: "_removeNullNode",
    value: function _removeNullNode() {
      var queue = [this];
      while (queue.length) {
        var current = queue.shift();
        if (current.left && current.left.val === null) {
          current.left = null;
        }
        if (current.right && current.right.val === null) {
          current.right = null;
        }
        if (current.left) {
          queue.push(current.left);
        }
        if (current.right) {
          queue.push(current.right);
        }
      }
      return this;
    }
  }, {
    key: "bfs",
    value: function bfs() {
      var queue = [this];
      var output = [];
      while (queue.length) {
        var node = queue.shift();
        output.push(node.val);
        if (node.left) {
          queue.push(node.left);
        }
        if (node.right) {
          queue.push(node.right);
        }
      }
      return output;
    }
  }, {
    key: "inOrder",
    value: function inOrder() {
      var stack = [];
      var output = [];
      var current = this;
      while (current || stack.length) {
        if (current) {
          stack.push(current);
          current = current.left;
        } else {
          current = stack.pop();
          output.push(current.val);
          current = current.right;
        }
      }
      return output;
    }
  }], [{
    key: "fromBFS",
    value: function fromBFS(arr) {
      var rootNode = new TreeNode(arr.shift());
      return arr.reduce(function (prev, current) {
        return prev.insert(current);
      }, rootNode)._removeNullNode();
    }
  }]);

  return TreeNode;
}();

exports.default = TreeNode;